var EXPORTED_SYMBOLS = ["Registry"];

var Registry = {
	get registryModule () {
		if (this.__registryWorker == null) {
			this.__registryWorker = Components.classes["@mozilla.org/windows-registry-key;1"];
			if (this.__registryWorker)
			    this.__registryWorker = this.__registryWorker.createInstance(Components.interfaces.nsIWindowsRegKey);
		}
		return this.__registryWorker;
	},
	
	get HKCU () {
		return (this.registryModule) ? this.registryModule.ROOT_KEY_CURRENT_USER : null;
	},
	
	get HKLM () {
		return (this.registryModule) ? this.registryModule.ROOT_KEY_LOCAL_MACHINE : null;
	},
			
	readRegistryStringValue: function (key, path, value) {
		try {
			
			if (this.registryModule == null)
				return;
			
			this.registryModule.open(key, path, this.registryModule.ACCESS_READ);

			let val = this.registryModule.readStringValue(value);
			
			this.registryModule.close();
			
			return val;
		} catch (e) {
			return null;
		}
		
	},
	
	writeRegistryStringValue: function (key, path, valueName, value) {
		try {
			
			if (this.registryModule == null)
				return;
			
			this.registryModule.create(key, path, this.registryModule.ACCESS_WRITE);

			let val = this.registryModule.writeStringValue(valueName, value);
			
			this.registryModule.close();
			
			return true;
		} catch (e) {
			return false;
		}
	}
};