var EXPORTED_SYMBOLS = ["RLLib"];

const {
	classes: Cc,
	interfaces: Ci,
	results: Cr,
	utils: Cu
} = Components;


var RLLib = {
    getContents: function (aURL) {
        let ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
        let scriptableStream = Cc["@mozilla.org/scriptableinputstream;1"].getService(Ci.nsIScriptableInputStream);

        let channel = ioService.newChannel(aURL, null, null);
        let input = channel.open();
        scriptableStream.init(input);
        let str = scriptableStream.read(input.available());
        scriptableStream.close();
        input.close();
        return str;
    },
    
    injectScriptToDoc: function (doc, scriptChromeURL) {
    
        var script = doc.createElement("script");
        script.setAttribute("src", "data:text/javascript;base64," + btoa(RLLib.getContents(scriptChromeURL)));
        script.setAttribute("type", "text/javascript");
        script.setAttribute("charset", "UTF-8");
        doc.body.appendChild(script);
        
    },
    
    execScriptToDoc: function (doc, scriptText) {
        var script = doc.createElement("script");
        script.setAttribute("src", "data:text/javascript;base64," + btoa(scriptText));
        script.setAttribute("type", "text/javascript");
        script.setAttribute("charset", "UTF-8");
        doc.body.appendChild(script);
    },

    ClientAPIInstance : function (engineName) {
    
        var ClientAPI = {
                    
            _getClientName: function() {
                return engineName;
            },

            _getClientApiEventName: function() {
                return this._getClientName() + "-client-event";
            },

            _getAddonApiEventName: function() {
                return this._getClientName() + "-addon-event";
            },

            _getClientApiBridge: function() {
                return this._getClientName() + "-bridge";
            },

         
            sendResponse: function(sender, response) {
                let doc = this._document;;
                let a = doc.createEvent("Event");
                sender.setAttribute("response", response);
                a.initEvent("answerHandle", true, false);
                var timer = Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
                timer.initWithCallback(
                  { notify: function (tm) {
                    sender.dispatchEvent(a);
                  }}, 0, Ci.nsITimer.TYPE_ONE_SHOT);                
                
            },
            
            attachToDocument: function (document, callbackForMessages) {
                
                this._document = document;
                
                let $ = this;
                
                document.addEventListener($._getClientApiEventName(), function(e) {
                   if (callbackForMessages) 
                      callbackForMessages(e.target);
                }, false, true);
            
            }
        }

        return ClientAPI;
    }    
};
