var EXPORTED_SYMBOLS = ["XMLHelper"];

/// Contains some functions for working with XML                                                                             
var XMLHelper = {
  // Evaluate an XPath expression aExpression against a given DOM node
  // or Document object (aNode), returning the results as an array
  // thanks wanderingstan at morethanwarm dot mail dot com for the
  // initial work.
  evaluateXPath: function (aNode, aExpr, ownerDoc)   {
    var xpe = Components.classes["@mozilla.org/dom/xpath-evaluator;1"]
                        .createInstance(Components.interfaces.nsIDOMXPathEvaluator);
    let owner = aNode.ownerDocument == null ?
      aNode.documentElement : aNode.ownerDocument.documentElement; 
    
    if (owner == null)
      owner = ownerDoc;
      
    let nsResolver = xpe.createNSResolver(owner);
    let result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
    let found = [];
    let res;
    while (res = result.iterateNext())
      found.push(res);
      
    return found;
  },
  // Parses btn node from xml entity to the array
  parseBtnNode: function (btnNode)  {
    let res = [];
    for (var i = 0; i < btnNode.length; i++)  {

        if (btnNode[i].nodeName == "menuitems" || btnNode[i].nodeName == "stations" || btnNode[i].nodeName == "list")
          res[btnNode[i].nodeName] = btnNode[i];
        else if (btnNode[i].childNodes.length > 0)
          res[btnNode[i].nodeName] = btnNode[i].childNodes[0].nodeValue;
        else
          res[btnNode[i].nodeName] = null;
    }
    
    return res; 
  },
  
  readXML: function(file){
    let url = "file:///" + file;
    while (url.indexOf("\\") != -1)
       url = url.replace("\\", "/")
    return this.readHTTPXML(url);
  },
  
  readHTTPXML: function(path)  {
    let request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                  .createInstance(Components.interfaces.nsIXMLHttpRequest);
    request.open("GET", path, false);
    request.send(null);
   
    return request.responseXML;
  },
  getChildNodeValue: function(root, nodeName) {
     var node = XMLHelper.evaluateXPath(root, nodeName);
     return node[0].childNodes[0].nodeValue;
  },
  saveXML: function(xmlDoc, file)  {
  	let serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer);
  	let foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
           .createInstance(Components.interfaces.nsIFileOutputStream);
  
  	foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);   // write, create, truncate
  	serializer.serializeToStream(xmlDoc, foStream, "");   // rememeber, doc is the DOM tree
  	foStream.close();
	  return true;
  },
  
  get parser() {
    return Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
  },
  
}; 

