(function(myname) {
  if (window.RLLibrary == null)
    return;
  var SysLib = new RLLibrary(myname);
  if (!SysLib || window.SearchBoxPopup)
    return;

  SysLib.AddonBridge.sendMessage("read-file", function(response) {
    SysLib.addStyle(response, "se-popup-style");
  }, "res/design/styles.css");

  SysLib.AddonBridge.sendMessage("add-script", function(response) {
  }, "res/suggestKiller.js");

  SysLib.AddonBridge.sendMessage("read-file", function(response) {

    var div = document.createElement("div");
    div.setAttribute("id", "se-wrapper");
    div.innerHTML = response;
    div.style.cssText = "display:none;";
    document.body.appendChild(div);

    var closeElement = document.getElementById("se-close");
    SysLib.event(closeElement, "onmousedown", function(e) {
      var element = e.target || e.srcElement;
      if (SearchBoxPopup)
        SearchBoxPopup.hide();
    }, false);


    SysLib.event(document.getElementById("disable-site"), "onmousedown", function(e) {
      var element = e.target || e.srcElement;

      if (SearchBoxPopup) {
        SearchBoxPopup.hide();
        SearchBoxPopup.Detach();
      }

      SysStorage.setKey("se-disabled", "true");
      document.body.removeChild(div);

    }, false);

    SysLib.event(document.getElementById("snooze-items"), "onmousedown", function(e) {

      var element = e.target || e.srcElement;
      if (SearchBoxPopup) {
        SearchBoxPopup.hide();
        SearchBoxPopup.Detach();
      }
      element = element.toString();
      var time = Number(element.substr(element.lastIndexOf("#") + 1, element.length));
      var toTime = (Date.now() + time * 60 * 1000);

      SysLib.AddonBridge.sendMessage("snooze-to", function(response) {
      }, toTime.toString());
    }, false);


    SysLib.AddonBridge.sendMessage("add-script", function(e) { }, "res/design/design.js");
    SysLib.AddonBridge.sendMessage("get-config-param", function(response) {
      document.getElementById("brand").innerHTML = response;
    }, "brandName");
    SysLib.AddonBridge.sendMessage("get-config-param", function(response) {
      document.getElementById("brand").style.cssText =
          "float: left; margin: 5px 0 0 7px; background: url(" + response +
          ") no-repeat 0 0px; display: inline-block;" +
          " padding-left: 16px; font-size: 12px;";
    }, "searchiconpath");

  }, "res/design/html");

  var Popup = {

    parseYahooSuggestResponse: function(response) {
      var index = response.indexOf("{");
      response = response.substr(index, response.lastIndexOf("}") - index + 1);

      var json = SysLib.parseJSON(response);
      var list = [];
      for (var i = 0; i < json["r"].length; i++) {
        var suggestion = json["r"][i][0];
        if (suggestion != null)
          list.push(suggestion);
      }
      return list;
    },

    handleEvent: function(e) {
      switch (e.type) {
        case "keydown":
          return Popup.onKeyDown(e);
        case "keyup":
          return Popup.onKeyUp(e);
        case "focus":
          return Popup.onFocus(e);
        case "blur":
          return Popup.onBlur(e);
        case "resize":
          return Popup.onResize(e);
      }
    },

    onKeyUp: function(e) {
      if (e.keyCode == 13) {
        return SysLib.stopEvent(e);
      }
      if (e.keyCode == 27) {
        Popup.hide();
        return;
      }
      if (e.keyCode == 40 || e.keyCode == 38)
        return;

      var element = e.target || e.srcElement;

      element._prevInput.setAttribute("value", element.value);
      element._prevInput.value = element.value;

      SysLib.AddonBridge.sendMessage("get-suggest", function(response) {
        var rect = element.getBoundingClientRect();
        var x = SysLib.getElementOffsetX(element), y = SysLib.getElementOffsetY(element) + Number(rect.bottom - rect.top);

        Popup.show(x, y, (rect.right - rect.left), Popup.parseYahooSuggestResponse(response), element._callback);
      }, element.value);

    },

    onResize: function(e) {
      Popup.hide();
    },

    onBlur: function(e) {
      Popup.hide();
    },

    onFocus: function(e) {
      var element = e.srcElement || e.target;
      if (element.value == (element.getAttribute("placeholder") || element._prevInput.defaultValue)) {
        element.value = "";
      } else element.removeAttribute("placeholder")
      Popup.hide();
    },

    onKeyDown: function(e) {
      var selectedText = Popup.getSelectedText();
      var element = e.target || e.srcElement;
      if (e.keyCode == 13 && Popup.isVisible() && selectedText != null) {

        if (element._callback != null)
          element._callback(selectedText);

        Popup.hide();
        document.body.focus();

        return SysLib.stopEvent(e);

      } else if (e.keyCode == 13) {
        if (element._prevInput && element._prevInput.fire) {
          element._prevInput.fire("onkeydown", e);
        }
        else if (element._prevInput.parentNode.submit) {
          element._prevInput.parentNode.submit();
        }
      }

      if (e.keyCode == 40) {
        Popup.switchNext();
      }
      if (e.keyCode == 38)
        Popup.switchPrev();
      return true;
    },

    getRelativeElement: function(element) {
      var parent = element.parentNode;
      var position = SysLib.getComputedStyle(parent, null).getPropertyValue("position");
      var positions = ["relative", "fixed", "absolute"];

      while (parent != null && parent.tagName.toLowerCase() != "body" && SysLib.indexInArray(positions, position) == -1) {

        parent = parent.parentNode;
        position = SysLib.getComputedStyle(parent, null).getPropertyValue("position");
      }
      return (parent.tagName.toLowerCase() == "body") ? null : parent;
    },

    IsDomain: function(domain) {
      return (document.domain == domain);
    },

    cloneInput: function(element) {
      var newInput = element.cloneNode(false);
      
      newInput.onkeyup = null;
      newInput.removeAttribute("onkeyup");
      newInput.removeAttribute("onkeypress");
      newInput.removeAttribute("onkeydown");

      newInput.setAttribute("autocomplete", "off");

      SysLib.copyStyles(element, newInput);

      if (document.domain == "search.mywebsearch.com") {
        newInput.style.width = "97%";
        newInput.style.border = "0";
      }
      newInput.style.className = (element.style.className != null) ? element.style.className : "";
      newInput.style.backgroundImage = (newInput.style.backgroundImage.indexOf("cse") != -1) ? "" : newInput.style.backgroundImage;

      element.parentNode.insertBefore(newInput, element);

      newInput.removeAttribute("id");
      newInput.removeAttribute("name");


      return newInput;
    },

    Attach: function(anchor, callback, xmlText) {

      if (anchor.getAttribute("se-attached") == "true")
        return;

      anchor.setAttribute("se-attached", "true");
      anchor.setAttribute("autocomplete", "off");

      var rect = anchor.getBoundingClientRect();


      var newInput = this.cloneInput(anchor);
      newInput._prevInput = anchor;
      anchor.style.display = "none";

      anchor.removeAttribute("onblur");

      anchor.removeAttribute("onkeyup");
      anchor.removeAttribute("onkeydown");
      anchor.removeAttribute("onkeypress");

      anchor.onkeyup = null;
      anchor.onkeydown = null;
      anchor.onkeypress = null;

      if (Popup._anchors == null)
        Popup._anchors = [];

      Popup._anchors.push(newInput);
      newInput._callback = callback;

      SysLib.event(newInput, "onfocus", Popup.handleEvent, false);
      SysLib.event(newInput, "onblur", Popup.handleEvent, false);

      SysLib.event(newInput, "onkeydown", Popup.handleEvent, false);
      SysLib.event(newInput, "onkeyup", Popup.handleEvent, false);
      SysLib.event(window, "onresize", Popup.handleEvent, false);

      Popup.postProcessing(anchor, newInput, xmlText);

    },

    postProcessing: function(anchor, newInput, xmlText) {
      if (xmlText != null && xmlText != "0") {

        var xmlDoc = SysLib.parseXMLFromString(xmlText);
        var scriptElement = xmlDoc.getElementsByTagName("post_script")[0];

        if (scriptElement != null) {
          try {
            eval(scriptElement.text || scriptElement.textContent);
          } catch (e) { }
        }
      }
    },

    Detach: function() {
      if (Popup._anchors == null)
        return;
      for (var i = 0; i < Popup._anchors.length; i++) {
        var anchor = Popup._anchors[i];
        SysLib.removeEvent(anchor, "onfocus", Popup.handleEvent, false);

        SysLib.removeEvent(anchor, "onblur", Popup.handleEvent, false);
        SysLib.removeEvent(anchor, "onkeydown", Popup.handleEvent, false);
        SysLib.removeEvent(anchor, "onkeyup", Popup.handleEvent, false);

      }
      Popup._anchors = null;
      SysLib.removeEvent(window, "onresize", Popup.handleEvent, false);
    },

    _newItem: function(keyword) {
      var li = document.createElement("li");
      var a = document.createElement("a");
      var text = document.createTextNode(keyword);
      a.appendChild(text);
      a.setAttribute("href", "#");
      li.appendChild(a);
      return li;
    },

    show: function(x, y, width, results, callback) {
      Popup._selectedText = null;
      if (results == null || results.length == 0) {
        Popup.hide();

        var iconqqq = document.getElementById("watch-video");
        iconqqq.style.border = '1px solid green';

        return;
      }

      var list = document.getElementById("keyword-list");

      while (list.childNodes.length)
        list.removeChild(list.childNodes[0]);

      for (var i = 0; i < results.length; i++) {
        var item = list.appendChild(this._newItem(results[i]));
        item.setAttribute("keyword", results[i]);
        SysLib.event(item, "onmousedown", function(e) {
          var element = e.target || e.srcElement;

          if (callback != null)
            callback(SysLib.getInnerText(element));
          Popup.hide();
          return SysLib.stopEvent(e);
        }, false);

        SysLib.event(item, "onmousemove", function(e) {
          var element = e.target || e.srcElement;
          Popup._setSelectedItem(SysLib.getInnerText(element));
        }, false);
      }

      if (Number(width) < 220) {
        width = 220;
      }

      var wrapper = document.getElementById("se-wrapper");

      wrapper.style.cssText = "display:block;z-index:999999;position:absolute;left:" + x + "px;top:" + y + "px;width:" + width + "px;";

    },

    _setSelectedItem: function(text) {
      this._selectedText = text;
      var list = document.getElementById("keyword-list");
      for (var i = 0; i < list.childNodes.length; i++) {
        var item = list.childNodes[i];
        item.style.cssText = (SysLib.getInnerText(item) == text) ? "background: #CACCCB;" : "";
      }
    },


    hide: function() {

      var wrapper = document.getElementById("se-wrapper");
      if (wrapper) {
        wrapper.style.cssText = "display:none;";
      }

      this._selectedText = null;
    },

    isVisible: function() {
      try {
        var wrapper = document.getElementById("se-wrapper");
        return wrapper.style.cssText.toLowerCase().indexOf("visibility: hidden") == -1;
      } catch (e) {
        return false;
      }
    },

    getSelectedText: function() {
      return Popup._selectedText;
    },

    switchNext: function() {
      if (!Popup.isVisible())
        return;

      var list = document.getElementById("keyword-list");
      for (var i = 0; i < list.childNodes.length; i++) {
        var item = list.childNodes[i];
        if (Popup._selectedText == null || Popup._selectedText == "") {
          Popup._setSelectedItem(SysLib.getInnerText(item));
          return;
        }
        if (SysLib.getInnerText(item) == Popup._selectedText && (i + 1 < list.childNodes.length)) {
          var text = SysLib.getInnerText(list.childNodes[i + 1]);
          Popup._setSelectedItem(text);
          return;
        }
      }
    },

    switchPrev: function() {
      if (!Popup.isVisible())
        return;

      var list = document.getElementById("keyword-list");

      for (var i = list.childNodes.length - 1; i > -1; i--) {
        var item = list.childNodes[i];
        if (Popup._selectedText == null || Popup._selectedText == "") {
          Popup._setSelectedItem(SysLib.getInnerText(item));
          return;
        }
        if (SysLib.getInnerText(item) == Popup._selectedText && (i - 1 > -1)) {
          Popup._setSelectedItem(SysLib.getInnerText(list.childNodes[i - 1]));
          return;
        }
      }
    }
  };

  window.SearchBoxPopup = Popup;

})("search-suggestor");