(function(myname) {
  if (window.RLLibrary == null || document.body == null)
    return;
  /// *****************************************************
  /// Initialization
  /// *****************************************************
  var SysLib = new RLLibrary(myname);
  if (!SysLib)
    return;

  var chkdiv = document.createElement("div");
  chkdiv.setAttribute("id", "se-suggest-existance");
  document.body.appendChild(chkdiv);

  var inLightBoxPage = false;
  SysLib.AddonBridge.sendMessage("get-config-param", function(response) {
    var substr = response.substr(0, response.indexOf("s="));
    inLightBoxPage = (document.location.href.indexOf(substr) == 0);
  }, "lightboxUrl");

  /// *****************************************************
  /// Detection and attaching 
  /// *****************************************************
  function getParentForm(src) {
    var parent = src.parentNode;
    while (parent != null) {
      if (parent.tagName != null && parent.tagName.toLowerCase() == "form")
        return parent;
      parent = parent.parentNode;
    }
    return null;
  }

  function checkParentFormTo(src, attrval, count) {
    try {
      var parent = src.parentNode;
      var topParentsNumber = 0;
      while (parent != null) {
        if (parent.tagName != null && (parent.tagName.toLowerCase() == "form" || topParentsNumber++ == count)) {
          for (var i = 0; i < attrval.length; i++) {
            var id = parent.getAttribute("id");
            var name = parent.getAttribute("name");
            var cl = parent.style.className;

            if ((id != null && id.indexOf(attrval[i]) != -1) ||
                (name != null && name.indexOf(attrval[i]) != -1) ||
                (cl != null && cl.indexOf(attrval[i]) != -1))
              return true;
          }
        }
        parent = parent.parentNode;
      }
    } catch (e) {

    }
    return false;
  }

  function IsWhiteListed(element, data) {

    function isEqualled(a, b) {
      var nulled = SysLib.IsNullOrEmpty(a) || SysLib.IsNullOrEmpty(b);
      if (nulled)
        return true;
      return (a == b)
    }

    var xml = SysLib.parseXMLFromString(data);
    var domainNode = xml.getElementsByTagName("domain")[0];
    if (!domainNode)
      return false;
    var inputNode = domainNode.getElementsByTagName("input")[0];
    if (!inputNode)
      return false;
    if (!isEqualled(inputNode.getAttribute("id"), element.getAttribute("id")))
      return false;

    if (!isEqualled(inputNode.getAttribute("name"), element.getAttribute("name")))
      return false;

    var formNode = domainNode.getElementsByTagName("form")[0];
    if (!formNode)
      return true;
    var parentForm = getParentForm(element);
    if (!parentForm)
      return false;

    if (formNode.getAttribute("id") != null && !isEqualled(formNode.getAttribute("id"), parentForm.getAttribute("id")))
      return false;
    if (formNode.getAttribute("name") != null && !isEqualled(formNode.getAttribute("name"), parentForm.getAttribute("name")))
      return false;
    return true;
  }

  function IsWordpressSite() {
    try {
      var head = document.head || document.getElementsByTagName("head")[0];
      if (head == null || head.childNodes == null)
        return false;
        
      var links = head.getElementsByTagName("link");
      for (var i = 0; i < links.length; i++) {
        var element = links[i];
        var href = element.outerHTML;
        if (href != null && href.indexOf("wp-content") != -1)
          return true;
      }
    } catch (e) {
    
    }
    return false;
  }

  function IsSearchField(input) {
    if (input == null || input.tagName == null)
      return false;


    if (input.tagName.toLowerCase() != "input" &&
                input.tagName.toLowerCase() != "textarea")
      return false;

    var typeAttr = input.getAttribute("type");
    if ((typeAttr != null) && (
            (typeAttr.toLowerCase() == "submit") ||
            (typeAttr.toLowerCase() == "hidden") ||
            (typeAttr.toLowerCase().indexOf("pass") == 0)
            ))
      return false;
    return true;
  }

  function Attach(obj, whitelistData) {
    setTimeout(function() {
      SearchBoxPopup.Attach(obj, function(selected) {
        SysLib.AddonBridge.sendMessage("show-lightbox", function(e) { }, selected);
      }, whitelistData);
    }, 0);
  }

  function TryAttachTo(element, whitelistData) {

    var attached = element.getAttribute("se-attached");
    if (attached == "true")
      return false;

    var cseAndBlogsIds = ["\"cse\"", "cse-", "\"gsc\"", "gsc-"
                   , "\"gse\"", "gse-", "w2b-"];
    
    if (whitelistData != "0" && IsWhiteListed(element, whitelistData)) { // if whitelistedSite
    } else if (IsWordpressSite() && element.name == "s") {
    } else if (checkParentFormTo(element, cseAndBlogsIds, 4)) {
    } else return;

    if (window.SearchBoxPopup == null) {
      SysLib.AddonBridge.sendMessage("add-script", function(e) {
        Attach(element, whitelistData);
      }, "res/popup.js");
    } else
      Attach(element, whitelistData);
  }

  function attachToCollection(elements, whitelistData) {
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      if (!IsSearchField(element))
        continue;
      TryAttachTo(element, whitelistData);
    }
  }

  if (inLightBoxPage)
    return;

  function runPreScript(whitelistData) {
    var xmlDoc = SysLib.parseXMLFromString(whitelistData);
    var scriptElement = xmlDoc.getElementsByTagName("pre_script")[0];
    if (scriptElement != null) {
      setTimeout(function() {
        try {
          eval(scriptElement.text || scriptElement.textContent);
        } catch (e) { }
      }, 300);
    }
  }
  SysLib.AddonBridge.sendMessage("is-whitelisted", function(whitelistData) {

    if (whitelistData != null && whitelistData != "0") {
      runPreScript(whitelistData);
    }

    setTimeout(function() {
      attachToCollection(document.getElementsByTagName("input"), whitelistData);
      attachToCollection(document.getElementsByTagName("textarea"), whitelistData);
    }, 200)
  }, document.domain);

})("search-suggestor");