window.CreateRLStorageInstance = function (myname, SysLib) {

    function RLExtend(Child, Parent) {
        var F = function() { }
        F.prototype = Parent.prototype;
        Child.prototype = new F();
        Child.prototype.constructor = Child;
        Child.superclass = Parent.prototype;
    }
    
    function RLStorage() {

        if (RLStorage.superclass != null)
            RLStorage.superclass.constructor.apply(this, arguments)

        var $ = this;
        var _storageName = myname + "-storage";

        this.setKey = function RLStorage_setKey(name, value) {

            var storage = this._storage().getItem(_storageName);
            var storageObject = (storage != null) ? SysLib.parseJSON(storage) : {};
            storageObject[name] = value;
            this._storage().setItem(_storageName, SysLib.toJSON(storageObject));
        };

        this.getKey = function RLStorage_getKey(name, type) {
            try {
                var storage = this._storage().getItem(_storageName);
                var storageObject = (storage != null) ? SysLib.parseJSON(storage) : {};
                return storageObject[name];
            } catch (e) { return null; }
        };
    }
    
    function RlStorageOperation() {
        this._storage = function() {
            return localStorage;
        };
    };
    
    function RlIE7StorageOperation() {

        this._createStorageElement = function() {
            var storageInput = document.createElement("input");
            storageInput.setAttribute("id", myname + "-storage-element");
            storageInput.style.display = "none";
            storageInput.addBehavior("#default#userData");
            return document.body.appendChild(storageInput);
        },

        this._storage = function() {
            var StorageObject = {};
            StorageObject._storageElement = (document.getElementById(myname + "-storage-element") == null) ? this._createStorageElement() : document.getElementById(myname + "-storage-element");
            StorageObject.setItem = function(name, value) {
                this._storageElement.setAttribute(name, value);
                this._storageElement.save(myname + "-storage");
            };
            StorageObject.getItem = function(name) {
                this._storageElement.load(myname + "-storage");
                return this._storageElement.getAttribute(name);
            };

            return StorageObject;
        };

    };

    if (navigator.appVersion.indexOf("MSIE 7.0") != -1)
        RLExtend(RLStorage, RlIE7StorageOperation);
    else
        RLExtend(RLStorage, RlStorageOperation);


    return new RLStorage();

};

